#include<iostream>
#include<fstream>
#include <vector>

using namespace std;


const int MaxN = 100005, MOD = 666013;
vector<int> v[MaxN];

/* up[x] = nr de posibilitati de a partitiona subarborele cu radacina in x, astfel incat 
 * x sa nu apartina partitionarii (sa nu apartina vreunui cartel din subarborele sau)
 * 
 * dwn[x] = - II - astfel incat x sa apartina unui cartel din subarborele sau 
 */ 
int n, k, viz[MaxN], t[MaxN], up[MaxN], dwn[MaxN], cartel[MaxN];

void Read();
void Solve(int nod); 
void Write();

int main() 
{
    Read();
    Solve(1);
    Write();
}

void Solve(int nod) 
{
    viz[nod] = 1;

    for( const int& f : v[nod])  
        if (!viz[f]) 
        {
            t[f] = nod;
            Solve(f);
        }    

    if (v[nod].size() == 1 && nod != 1) // frunza
    {
        if (cartel[nod]) 
        {
            dwn[nod] = 1;
            up[nod] = 0;
        } 
        else 
        {
            dwn[nod] = 0;
            up[nod] = 1;
        }
        return ;
    }

    if (cartel[nod])     // nod interior 
    {
        up[nod] = 0;
        long long p = 1;
        for (const int& f : v[nod])
            if (f != t[nod]) 
                p = (p * (dwn[f] + up[f])) % MOD ;  // fiul f poate sau nu sa apartina cartelului nod
            
        dwn[nod] = p;    // nr de moduri in care nod poate fi cartel
    } 
    else 
    {
        long long p = 1;

        for (const int& f : v[nod])
           if (f != t[nod])
                p = (p * (dwn[f] + up[f])) % MOD ; 
        up[nod] = p;    // nr moduri in care nod poate apartine unui cartel de "sus"

        for (const int& f1 : v[nod])      // nod trebuie obligatoriu sa faca parte dintr-un cartel in care e inclus unul dintre fii
            if (f1 != t[nod]) 
            {	
                p = dwn[f1];                          // daca nod e inclus intr-un cartel din care face parte fiul f1
                for (const int& f2 : v[nod])
                    if (f1 != f2 && f2 != t[nod]) 
                        p = (p * (dwn[f2] + up[f2])) % MOD ; // atunci restul fiilor pot sa depinda de cartel de "sus" sau de "jos"
                    
                dwn[nod] = (dwn[nod] + p) % MOD ;
            }
    }
}

void Write() 
{
    ofstream fout("karb.out");
    fout << dwn[1] << '\n';
    fout.close();
}

void Read() 
{
    ifstream f("karb.in");
    f >> n >> k ;
    for ( int i = 0, x; i < k ; i++) 
    {
 
        f >> x;
        cartel[x] = 1;
    }

    for (int i = 1, x, y; i < n; i++) 
    {
        f >> x >> y ;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    f.close();
}
