//Mihai Popa
//backtracking, 10p

#include<stdio.h>
#include<vector>
#include<algorithm>
#include<queue>
#include<cassert>

#define maxdim 200005
#define mod 666013

using namespace std;

int n,k,sol;
int special[maxdim],colorat[maxdim],T[maxdim];
vector<int>G[maxdim],speciale,gives[maxdim];

inline int check () {
	
	for ( int i = 1 ; i <= n ; ++i ){
		gives[i].clear();
	}
	for ( int i = 1 ; i <= n ; ++i ){
		gives[T[i]].push_back(i);
	}
	
	queue<int>Q; vector<int>c(n+1,0);
	for ( int i = 0 ; i < (int)speciale.size() ; ++i ){
		Q.push(speciale[i]);
		c[speciale[i]] = speciale[i];
	}
	
	while ( !Q.empty() ){
		int nod = Q.front(); Q.pop();
		for ( vector<int>::iterator itt = gives[nod].begin() ; itt != gives[nod].end() ; ++itt ){
			int vecin = (*itt);
			if ( c[vecin] )	return 0;
			c[vecin] = c[nod];
			Q.push(vecin);
		}
	}
	
	for ( int i = 1 ; i <= n ; ++i ){
		if ( !c[i] )	return 0;
	}
	return 1;
}

void back ( int nod ) {
	
	if ( nod == n+1 ){
		sol += check();
		return ;
	}
	
	if ( special[nod] ){
		back(nod+1);
		return ;
	}
	
	for ( vector<int>::iterator itt = G[nod].begin() ; itt != G[nod].end() ; ++itt ){
		int vecin = (*itt);
		
		if ( T[vecin] != nod ){
			T[nod] = vecin;
			back(nod+1);
			T[nod] = 0;
		}
	}
}

int main () {
	
	freopen("karb.in","r",stdin);
	freopen("karb.out","w",stdout);
	
	scanf("%d %d",&n,&k);
	assert(n >= 1 && n <= 200000);
	assert(k >= 1 && k <= n);
	int x,y;
	for ( int i = 1 ; i <= k ; ++i ){
		scanf("%d",&x);
		assert(!special[x]);
		assert(x >= 1 && x <= n);
		special[x] = x;
		speciale.push_back(x);
	}
	for ( int i = 1 ; i < n ; ++i ){
		scanf("%d %d",&x,&y);
		assert(x >= 1 && x <= n);
		assert(y >= 1 && y <= n);
		assert(x != y);
		G[x].push_back(y);
		G[y].push_back(x);
	}
	
	back(1);
	
	printf("%d\n",sol);
	
	return 0;
}

